//////////////////////////////////////////////////////////////////////////////////////////
// NcCT32B0.c
//
// ■更新履歴
// 2011/07/10 NanaCraft
//            ・新規作成。
//
//////////////////////////////////////////////////////////////////////////////////////////

#include "NcMb.h"

///////////////////////////////////////////////////////////////////////////////
// Counter/Timer関連

void NcCT32B0StopwatchInitialize(uint32_t divideBy)
{
    LPC_TMR32B0->TCR = 0b00;    // CEn=0, CRst=0

    LPC_TMR32B0->CTCR = 0b0000; // CTM=0, CIS=0
    LPC_TMR32B0->PR = divideBy - 1;
    LPC_TMR32B0->TC = 0;        // TC=0
}

uint32_t NcCT32B0StopwatchStart()
{
    uint32_t value = LPC_TMR32B0->TC;
    LPC_TMR32B0->TCR = 0b01;    // CEn=1, CRst=0
    return value;
}

uint32_t NcCT32B0StopwatchStop()
{
    LPC_TMR32B0->TCR = 0b00;    // CEn=0, CRst=0
    return LPC_TMR32B0->TC;
}

uint32_t NcCT32B0StopwatchReset()
{
    uint32_t value;
    LPC_TMR32B0->TCR = 0b00;    // CEn=0, CRst=0
    value = LPC_TMR32B0->TC;

    LPC_TMR32B0->TC = 0;

    return value;
}

uint32_t NcCT32B0StopwatchRestart()
{
    uint32_t value;
    LPC_TMR32B0->TCR = 0b00;    // CEn=0, CRst=0
    value = LPC_TMR32B0->TC;

    LPC_TMR32B0->TC = 0;

    LPC_TMR32B0->TCR = 0b01;    // CEn=1, CRst=0

    return value;
}

uint32_t NcCT32B0StopwatchGetValue()
{
    return LPC_TMR32B0->TC;
}

//
///////////////////////////////////////////////////////////////////////////////
